use strict;
use Text::Wrap qw/wrap/;

my $nasm = 'nasm -f bin -DDEBUG';
my $boot = 'boot.asm.pre';
my $sec = 'sec.asm.pre';

sub mkboot {				# FIXME: Horrid code!!
	my ($file, $map, $image) = @_;
	print "Making vmzealoz:\n";

	my %data;

	open F, $map or die "ACK!!, $!";
	$_ = (grep /startPoint/, <F>)[0];

	$data{KERN_START} = (split ' ')[0];
	@data{qw/SYMS_START SYMS_LEN/} = &getSect(".funcSyms");
	@data{qw/FS_START FS_LEN/} = &getSect(".fsStructs");
	@data{qw/SYSCALL_START SYSCALL_LEN/} = &getSect(".syscalls");
	$data{KERN_BSS_SIZE} = int((&getSect(".bss"))[1] / 512) + 1;
	$data{KERN_LOAD} = (&getSect(".text"))[0];

	seek F, 0, 0;
	(split ' ', (grep /delableStart/, <F>)[0])[0] =~ /0x([\dA-Fa-f]+)/;
	$data{DELABLE_START} = hex $1;
	seek F, 0, 0;
	(split ' ', (grep /delableLength/, <F>)[0])[0] =~ /0x([\dA-Fa-f]+)/;
	$data{DELABLE_LEN} = hex $1;
	close F;

	$data{KERN_SIZE} = int((stat $file)[7] / 512) + 2;

	print "$_ => $data{$_}\n" for keys %data;

	my $tmp = parse($boot, \%data);
	my $tmpa = &mkTmp;
	my $str = "$nasm -o $tmpa $tmp";
	system($str) == 0 or die "nasm: $str failed, $!";
	unlink $tmp;

	$tmp = parse($sec, \%data);
	my $tmpb = &mkTmp;
	$str = "$nasm -o $tmpb $tmp";
	system($str) == 0 or die "nasm: $str failed, $!";
	unlink $tmp;

	local $/ = undef;
	open F, $tmpa or die "$tmpa (temp file) doesn't exist.. argg";
	my $final = <F>;
	close F;
	unlink $tmpa;
	open F, $tmpb or die "$tmpb (temp file) doesn't exist.. argg";
	$final .= <F>;
	close F;
	unlink $tmpb;
	open F, $file or die "$file doesn't exist.. argg";
	$final .= <F>;
	close F;
	open F, ">$image" or die "Can't open $image for writing, $!";
	print F $final;
	close F;
}

sub mkTmp {
	my @chars = ('a'..'z', 'A'..'Z', 0..9);
	my $fn;
	
	do {
		$fn = '';
		map {$fn .= $chars[rand @chars]} 0..(4 + rand 4);
	} while -e "$fn.tmp";

	return "$fn.tmp";
}

sub parse {
	my ($inp, $data) = @_;
	my $tmp = mkTmp();
	open F, $inp or die "Can't open input file $inp: $!";
	open G, ">$tmp" or die "Can't open output file $tmp: $!";
	while(<F>) {
		s/\b([A-Z_]+)\b/(exists $data->{$1})?$data->{$1}:$1/eg;
		print G
	}
	close F;
	close G;
	return $tmp;
}

sub getSect {
	my $t = shift;
	seek F, 0, 0;
	$/ = "\n";
	@_ = grep /$t/, <F>;
	for(@_) {
		return (hex $1,hex $2) if /^$t\s*0x([\dA-Fa-f]+)\s*0x([\dA-Fa-f]+)\s*$/;
	}
	return (0,0);
}

sub bootClean {
	unlink <*.tmp>;
}
"A true value"
