#!/usr/bin/perl
# ZealOS Operating System
# Copyright Mark Zealey (mark@itsolve.co.uk) 2000
# Last update: 27/06/01
#
# Usage: changeall.pl s/foo/bar/g
# Changes all occurances of foo to bar in all files

use strict;
use File::Find;
use Cwd;

$/ = undef;
my $a = join ' ', @ARGV;

sub t {
	return unless -f;
	my $t = $_;
	print "Changing $t:";
	open F, $t or do { print "Can't open the file $t for reading!!\n"; return };
	$_ = <F>;
	close F;

	print "\n";
	eval $a;
	open F, ">$t" or do { print "Can't open the file $t for writing!!\n"; return };
	
	print F;
	close F;
}

find(\&t,'./')

