#!/usr/bin/perl -w
# Finds the sub that the specified address(s) are in
# usage: findsub.pl [/path/to/elf] 0x1234 0x2345 ...
# Last update: 07/08/01

use strict;

my $elf = 'vmzealoz_elf';

@ARGV and $ARGV[0] !~ /^[a-fx\d]+$/i and $elf = shift;

!-f $elf and system 'make elf';

exec 'addr2line', '-e', $elf, @ARGV;
